import { world, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  const customCopperLamp = [
    "nicothekid:copper_lamp",
    "nicothekid:exposed_copper_lamp",
    "nicothekid:weathered_copper_lamp"
  ]
  initEvent.blockComponentRegistry.registerCustomComponent("nicothekid:copper_lamp_oxidization", {
    onRandomTick: eventData => {
      const block = eventData.block;
      const blockLocation = block.location;
      const blockAllState = block.permutation.getAllStates();
      if (customCopperLamp.includes(block.typeId)) {
        let oxidizationChance = Math.random();
        if (block.permutation.matches("nicothekid:copper_lamp")) {
          if (oxidizationChance <= 0.01) {
            block.setPermutation(BlockPermutation.resolve("nicothekid:exposed_copper_lamp"));
            return;
          }
          else return;
        }
        if (block.permutation.matches("nicothekid:exposed_copper_lamp")) {
          if (oxidizationChance <= 0.01) {
            block.setPermutation(BlockPermutation.resolve("nicothekid:weathered_copper_lamp"));
            return;
          }
          else return;
        }
        if (block.permutation.matches("nicothekid:weathered_copper_lamp")) {
          if (oxidizationChance <= 0.01) {
            block.setPermutation(BlockPermutation.resolve("nicothekid:oxidized_copper_lamp"));
            return;
          }
          else return;
        }
      }
      else return;
    }
  });
});